import numpy as np
import pyeddl.eddl as eddl
from pyeddl.tensor import Tensor

def net_getParameters(model):

	all_params = []
	gradients = []

	i = 0
	for layer in model.layers:

		params = list()
		#print("Layer", i)
		#print("Size: ", len(layer.params))

		if len(layer.params) > 0:
			#print(layer.params[0])
			#print("Weights shape: ", layer.params[0].getShape())

			weights = np.array(layer.params[0], copy=True).astype(np.float32)
			params.append(weights)



			if len(layer.params) > 1:

				#print("Bias shape: ", layer.params[1].getShape())
				bias = np.array(layer.params[1], copy=True).astype(np.float32)
				params.append(bias)
		gradients.append(layer.gradients)

		all_params.append(params)
		i += 1

	return all_params, gradients


def net_insertParameters(model, final_weights):

	print("net_insertParameters")

	# DESC
	print("Los pesos que voy a enchufar en insertParameters: ", final_weights)

	# DESC
	#print("Teoricamente no enchufados en insertParameters: ", net_getParameters(model))

	var = list()
	var.append("Hola")

	#model.layers[0].params = var

	#print("Model insertParam: ", model.layers[0].params)

	# Params de una layer concreta son:
	#type(model.layers[i].params) == <class 'list'>
	# params[0] = Tensor()
	# params[1] = Tensor()

	print("Numero de layers: ", len(model.layers))

	for i in range(0, len(model.layers)):

		params_aux = list()
		print("Layer", i)
		print("Size: ", len(model.layers[i].params))

		if len(model.layers[i].params) > 0:

			v = eddlT.create(final_weights[i][0].astype(np.float32))
			v = eddlT.toCPU(v)

			print("Info weights que entra")
			v.info()
			print("Info weights que hay")
			model.layers[i].params[0].info()
			#print("Weights shape: ", eddlT.getShape(v))

			#layers[i].params[0] = v
			params_aux.append(v)

			if len(model.layers[i].params) > 1:

				v = eddlT.create(final_weights[i][1].astype(np.float32))
				v = eddlT.toCPU(v)

				print("Info bias que entra")
				v.info()
				print("Info bias que hay")
				model.layers[i].params[1].info()
				#print("Bias shape: ", eddlT.getShape(v))

				params_aux.append(v)
				#layers[i].params[1] = v
				#params_aux.append(eddlT.create(final_weights[i][1], eddlT.DEV_CPU))
				#model.layers[i].params[1] = eddlT.create(final_weights[i][1])

		#model.layers[i].params = params_aux

	#model.layers = layers
	# DESC
	print("Teoricamente enchufados en insertParameters: ", net_getParameters(model))
	return model

#Que reciba dos elementos de cada vez, el weight y el acumulado anterior
#Primero probarla tal cual y luego con concurrent.
# Acumulado = INOUT nuevo weight = IN
def net_aggregateParameters(workers_parameters):

	NUM_WORKERS = len(workers_parameters)
	recv_weights = workers_parameters

	final_weights = recv_weights[0]

	for i in range(0, len(final_weights)):

		layer_final = final_weights[i]

		if len(layer_final) > 0:
		
			for j in range(1, NUM_WORKERS):

				layer_recv = recv_weights[j][i]
				layer_final[0] = np.add(layer_final[0], layer_recv[0])

				if len(layer_final) > 1:
					layer_final[1] = np.add(layer_final[1], layer_recv[1])

			layer_final[0] = np.divide(layer_final[0], NUM_WORKERS)

			if len(layer_final) > 1:
				layer_final[1] = np.divide(layer_final[1], NUM_WORKERS)

			#print("Final weights[i]: ", final_weights[i])
			#print("Layer final", layer_final)

	return final_weights


def net_parametersToNumpy(parameters):

	np_params = list()

	for i in range(0, len(parameters)):

		params = list()

		for j in range(0, len(parameters[i])):

			v = np.array(parameters[i][j], copy=True).astype(np.float32)
			#print("V: ", v)
			#v = eddlT.getdata(parameters[i][j])
			params.append(v)

		np_params.append(params)

	return np_params


def net_parametersToTensor(parameters):
	tensor_params = list()

	for i in range(0, len(parameters)):

		params = list()
		for j in range(0, len(parameters[i])):
			#print(parameters[i][j])
			v = Tensor.fromarray(np.array(parameters[i][j], copy=True).astype(np.float32))
			#print(v)
			#v = eddlT.create(parameters[i][j].astype(np.float32))
			#v.info()
			#v = eddlT.toCPU(v)
			params.append(v)

		tensor_params.append(params)
	return tensor_params

'''@task(serialized_model=IN, returns=int, is_replicated=True)
def build_prueba(serialized_model):

    if environ.get('EDDL_DIR') is not None:
        print("Inside Esta presente la varrr")
    else:
        print("Inside NO esta la var")
    return 0'''


def save_fnc(fichero, parameters):

    f = open(fichero, "a")

    for i in range(0, len(parameters)):

        for j in range(0, len(parameters[i])):

            v = parameters[i][j]
            np.savetxt(f, v)